'From MIT Squeak 0.9.4 (June 1, 2003) [No updates present.] on 23 July 2008 at 7:53:44 am'!
Object subclass: #WsSound
	instanceVariableNames: 'frequency level '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WS-Sound-Primitives'!
WsSound class
	instanceVariableNames: ''!
Object subclass: #WsWorldStethoscope
	instanceVariableNames: 'soundInput fft sounds offset cutOffLevel sortType listening passOver passUnder '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WS-Sound-Interface'!
WsWorldStethoscope class
	instanceVariableNames: 'default '!

!ScriptableScratchMorph methodsFor: 'sensing ops' stamp: 'ka 5/20/2007 20:53'!
soundInputFrequency
	| ws |
	ws _ WsWorldStethoscope default.
	ws processBuffer.
	^ ws frequency! !

!ScriptableScratchMorph methodsFor: 'sensing ops' stamp: 'ka 5/20/2007 20:53'!
soundInputLevel
	| ws |
	ws _ WsWorldStethoscope default.
	ws processBuffer.
	^ ws level! !

!ScriptableScratchMorph methodsFor: 'sensing ops' stamp: 'ka 5/20/2007 20:27'!
soundInputOff
	WsWorldStethoscope default stop! !

!ScriptableScratchMorph methodsFor: 'sensing ops' stamp: 'ka 5/20/2007 20:26'!
soundInputOn
	WsWorldStethoscope default start! !


!ScratchSpriteMorph class methodsFor: 'scratch' stamp: 'ka 7/23/2008 07:51'!
blockSpecs

	| blocks |
	blocks _ #(
		'motion'
			('move %n steps'				-	forward:)
			('turn %n degrees'				-	turnRight: 15)	"icon shows turn direction"
			('turn %n degrees'				-	turnLeft: 15)	"icon shows turn direction"
			-
			('point in direction %d'			-	heading: 90)
			('point towards %m'				-	pointTowards:)
			-
			('go to x:%n y:%n'				-	gotoX:y: 0 0)
			('go to %m'						-	gotoSpriteOrMouse:)
			('glide %n secs to x:%n y:%n'	t	glideSecs:toX:y:elapsed:from: 1 50 50)
			-
			('change x by %n'				-	changeXposBy: 10)
			('set x to %n'					-	xpos: 0)
			('change y by %n'				-	changeYposBy: 10)
			('set y to %n'					-	ypos: 0)
			-
			('if on edge, bounce'			-	bounceOffEdge)
			-
			('x position'						r	xpos)
			('y position'						r	ypos)
			('direction'						r	heading)
		'pen'
			('clear'							-	clearPenTrails)
			-
			('pen down'						-	putPenDown)
			('pen up'						-	putPenUp)
			-
			('set pen color to %c'			-	penColor:)
			('change pen color by %n'		-	changePenHueBy:)
			('set pen color to %n'			-	setPenHueTo: 0)
			-
			('change pen shade by %n'		-	changePenShadeBy:)
			('set pen shade to %n'			-	setPenShadeTo: 50)
			-
			('change pen size by %n'		-	changePenSizeBy: 1)
			('set pen size to %n'				-	penSize: 1)
			-
			('stamp'							-	stampCostume)
	).

	blocks _ blocks, #(
		'looks'
			('switch to costume %l'			-	lookLike:)
			('next costume'					-	nextCostume)
			('costume #'						r	costumeIndex)
			-
			('say %s for %n secs'			t	say:duration:elapsed:from: 'Hello!!' 2)
			('say %s'						-	say: 'Hello!!')
			('think %s for %n secs'			t	think:duration:elapsed:from: 'Hmm...' 2)
			('think %s'						-	think: 'Hmm...')
			-
			('change %g effect by %n'		-	changeGraphicEffect:by: 'color' 25)
			('set %g effect to %n'			-	setGraphicEffect:to: 'color' 0)
			('clear graphic effects'			-	filterReset)
			-
			('change size by %n'			-	changeSizeBy:)
			('set size to %n%'				-	setSizeTo: 100)
			('size'							r	scale)
			-
			('show'							-	show)
			('hide'							-	hide)
			-
			('go to front'					-	comeToFront)
			('go back %n layers'			-	goBackByLayers: 1)
		'sensing'
			('mouse x'						r	mouseX)
			('mouse y'						r	mouseY)
			('mouse down?'					b	mousePressed)
			-
			('key %k pressed?'				b	keyPressed: 'space')
			-
			('touching %m?' 				b	touching:)
			('touching color %C?' 			b	touchingColor:)
			('color %C is touching %C?'		b	color:sees:)
			-
			('distance to %m'				r	distanceTo:)
			-
			('reset timer'					-	timerReset)
			('timer'							r	timer)
			-
			('%a of %m'						r	getAttribute:of:)
			-
			('loudness'						r	soundLevel)
			('loud?'							b	isLoud)
			-
			('%H sensor value'				r	sensor: 'slider')
			('sensor %h?'					b	sensorPressed: 'button pressed')
			-
			('sound input on'				-	soundInputOn)
			('sound input off'				-	soundInputOff)
			('sound input frequency'		r	soundInputFrequency)
			('sound input level'				r	soundInputLevel)
		).

	^ blocks, super blockSpecs
! !


!WsSound methodsFor: 'accessing' stamp: 'ka 7/29/2003 22:14'!
frequency
	^ frequency! !

!WsSound methodsFor: 'accessing' stamp: 'ka 7/29/2003 22:14'!
frequency: aNumber 
	frequency _ aNumber! !

!WsSound methodsFor: 'accessing' stamp: 'ka 7/30/2003 00:33'!
frequency: frequencyNumber level: levelNumber 
	self frequency: frequencyNumber.
	self level: levelNumber! !

!WsSound methodsFor: 'accessing' stamp: 'ka 7/29/2003 22:14'!
level
	^ level! !

!WsSound methodsFor: 'accessing' stamp: 'ka 7/29/2003 22:15'!
level: aNumber 
	level _ aNumber! !

!WsSound methodsFor: 'initialize-release' stamp: 'ka 7/29/2003 22:19'!
initialize
	frequency _ level _ 0! !

!WsSound methodsFor: 'musical scaling' stamp: 'tetha 9/25/2003 17:45'!
musicalScaleName

	^self class musicalScaleNameOf: self frequency! !

!WsSound methodsFor: 'printing' stamp: 'ka 7/29/2003 22:25'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPut: $(.
	self frequency printOn: aStream.
	aStream nextPut: Character space.
	self level printOn: aStream.
	aStream nextPut: $)! !


!WsSound class methodsFor: 'musical scaling' stamp: 'tetha 9/25/2003 18:47'!
musicalScaleC0Frequency
	^ 16.351 ! !

!WsSound class methodsFor: 'musical scaling' stamp: 'tetha 9/25/2003 18:55'!
musicalScaleNameOf: aNumber
	| index |
	aNumber < self musicalScaleC0Frequency ifTrue: [^'unknown'].
	index _ (((aNumber / self musicalScaleC0Frequency) log:2) * 12) rounded \\ 12.
	^self musicalScaleNames at: index + 1! !

!WsSound class methodsFor: 'musical scaling' stamp: 'tetha 9/25/2003 18:51'!
musicalScaleNames
	^ #('C' 'C#' 'D' 'D#' 'E' 'F' 'F#' 'G' 'G#' 'A' 'A#' 'B' )! !

!WsSound class methodsFor: 'examples' stamp: 'ka 7/29/2003 22:27'!
example1
	"WsSound example1"
	^ self frequency: 1000 level: 10! !

!WsSound class methodsFor: 'examples' stamp: 'tetha 9/25/2003 17:52'!
example2
	"WsSound example2"
	| frequencies |
	frequencies _ #(261.6 293.6 329.6 349.2 392 440 493.8 523.3 ).
	^ frequencies
		collect: [:f | WsSound musicalScaleNameOf: f]! !

!WsSound class methodsFor: 'examples' stamp: 'tetha 9/25/2003 17:53'!
example3
	"WsSound example3"
	| frequencies |
	frequencies _ #(454 94324 898423 333 432 8586 1 2).
	^ frequencies
		collect: [:f | WsSound musicalScaleNameOf: f]! !

!WsSound class methodsFor: 'instance creation' stamp: 'ka 7/30/2003 00:34'!
frequency: frequency level: level 
	"WsSound frequency: 1000 level: 10"
	^ self new frequency: frequency level: level! !

!WsSound class methodsFor: 'instance creation' stamp: 'ka 7/29/2003 22:20'!
new
	^ super new initialize! !


!WsWorldStethoscope methodsFor: 'processing' stamp: 'tetha 1/11/2004 22:55'!
processBuffer
	| buffer |
	soundInput bufferCount = 0
		ifTrue: [^ self].
	[soundInput bufferCount > 0]
		whileTrue: [buffer _ soundInput nextBufferOrNil].
	self
		updateSounds: (fft transformDataFrom: buffer startingAt: 1)! !

!WsWorldStethoscope methodsFor: 'processing' stamp: 'ka 12/31/2006 01:43'!
updateSounds: analizedData 
	| factor passUnderValue passOverValue deltas |
	factor := soundInput samplingRate / fft n.
	passUnderValue := self passUnder / factor.
	passOverValue := self passOver / factor.
	deltas := Array new: analizedData size - 1.
	1
		to: deltas size
		do: [:index | 
			| delta | 
			delta := (passOverValue < index
							and: [index < passUnderValue])
						ifTrue: [(analizedData at: index + 1)
								- (analizedData at: index)]
						ifFalse: [0].
			deltas at: index put: index -> delta].
	deltas := deltas
				asSortedCollection: [:a :b | a value < b value].
	1
		to: 3
		do: [:index | 
			| n level frequency | 
			n := (deltas at: index) key - 1 max: 1.
			level := analizedData at: n.
			frequency := level < self cutOffLevel
						ifTrue: [frequency := 0.
							level := 0]
						ifFalse: [frequency := (n * factor) truncated].
			(sounds at: index)
				frequency: frequency + self offset
				level: level].
	sounds := self isSortByLevel
				ifTrue: [(sounds
						asSortedCollection: [:a :b | a level > b level]) asArray]
				ifFalse: [(sounds
						asSortedCollection: [:a :b | a frequency > b frequency]) asArray]! !

!WsWorldStethoscope methodsFor: 'control' stamp: 'tetha 1/11/2004 23:03'!
cutOffLevelDecrease
	| newValue |
	newValue _ self cutOffLevel - 1000.
	self cutOffLevel: newValue.! !

!WsWorldStethoscope methodsFor: 'control' stamp: 'tetha 1/11/2004 23:03'!
cutOffLevelIncrease
	| newValue |
	newValue _ self cutOffLevel + 1000.
	self cutOffLevel: newValue.! !

!WsWorldStethoscope methodsFor: 'control' stamp: 'tetha 1/11/2004 23:04'!
offsetDecrease
	| newValue |
	newValue _ self offset - 1.
	self offset: newValue.! !

!WsWorldStethoscope methodsFor: 'control' stamp: 'tetha 1/11/2004 23:04'!
offsetIncrease
	| newValue |
	newValue _ self offset + 1.
	self offset: newValue.! !

!WsWorldStethoscope methodsFor: 'control' stamp: 'tetha 1/11/2004 23:04'!
setFFTSize
	| menu fftSize on |
	menu _ CustomMenu new title: 'FFT size (currently ' translated, fft n printString , ')'.
	((7 to: 10)
		collect: [:n | 2 raisedTo: n])
		do: [:r | menu add: r printString action: r].
	fftSize _ menu startUp.
	fftSize
		ifNil: [^ self].
	on _ soundInput isRecording.
	self stop.
	fft _ FFT new: fftSize.
	on
		ifTrue: [self start]! !

!WsWorldStethoscope methodsFor: 'control' stamp: 'tetha 1/11/2004 23:05'!
setSamplingRate
	| menu rate on |
	menu _ CustomMenu new title:
		'Sampling rate (currently ' translated, soundInput samplingRate printString, ')'.
	#(11025 22050 44100) do:[:r | menu add: r printString action: r].
	rate _ menu startUp.
	rate ifNil: [^ self].
	on _ soundInput isRecording.
	self stop.
	soundInput samplingRate: rate.
	on ifTrue: [self start].

! !

!WsWorldStethoscope methodsFor: 'control' stamp: 'tetha 1/12/2004 23:29'!
start
	soundInput bufferSize: fft n.
	soundInput startRecording.
	listening _ true! !

!WsWorldStethoscope methodsFor: 'control' stamp: 'tetha 1/12/2004 23:29'!
stop
	soundInput stopRecording.
	listening _ false! !

!WsWorldStethoscope methodsFor: 'fileIn/out' stamp: 'tetha 1/13/2004 00:21'!
storeDataOn: aDataStream 
	| savedState |
	savedState _ self isListening.
	"soundInput stopRecording."
	self stop.
	[super storeDataOn: aDataStream]
		ensure: [savedState
				ifTrue: [self start]]! !

!WsWorldStethoscope methodsFor: 'phone utilities' stamp: 'tetha 1/11/2004 22:54'!
dialNumber
	| permissibleRange lows highs lowFrequency highFrequency numbers index |
	permissibleRange _ self permissibleRange.
	lows _ self lowFrequencies.
	highs _ self highFrequencies.
	numbers _ self dialNumbers.
	lowFrequency _ nil.
	highFrequency _ nil.
	sounds
		do: [:each | 
			| frequency | 
			frequency _ each frequency rounded.
			lowFrequency isNil
				ifTrue: [lows
						detect: [:low | 
							lowFrequency _ low.
							(low - permissibleRange to: low + permissibleRange)
								includes: frequency]
						ifNone: [lowFrequency _ nil]].
			highFrequency isNil
				ifTrue: [highs
						detect: [:high | 
							highFrequency _ high.
							(high - permissibleRange to: high + permissibleRange)
								includes: frequency]
						ifNone: [highFrequency _ nil]]].
	lowFrequency isNil
		ifTrue: [^ ''].
	highFrequency isNil
		ifTrue: [^ ''].
	index _ (lows indexOf: lowFrequency)
				- 1 * 4
				+ (highs indexOf: highFrequency).
	^ (numbers at: index) asString! !

!WsWorldStethoscope methodsFor: 'phone utilities' stamp: 'tetha 1/11/2004 22:54'!
dialNumbers
	^ '123A456B789C*0#D' copy! !

!WsWorldStethoscope methodsFor: 'phone utilities' stamp: 'tetha 1/11/2004 22:54'!
highFrequencies
	^ #(1209 1336 1477 1633 ) copy! !

!WsWorldStethoscope methodsFor: 'phone utilities' stamp: 'tetha 1/11/2004 22:55'!
lowFrequencies
	^ #(697 770 852 941 ) copy! !

!WsWorldStethoscope methodsFor: 'phone utilities' stamp: 'tetha 1/11/2004 22:55'!
permissibleRange
	^ 30! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:56'!
cutOffLevel
	^ cutOffLevel! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:57'!
cutOffLevel: number 
	cutOffLevel _ number! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/12/2004 23:36'!
frequency
	^ self frequency1! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:57'!
frequency1
	^ sounds first frequency max: 0! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:57'!
frequency2
	^ sounds second frequency max: 0! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:57'!
frequency3
	^ sounds third frequency max: 0! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/12/2004 23:37'!
level
	^ self level1! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:57'!
level1
	^ sounds first level! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:58'!
level2
	^ sounds second level! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:58'!
level3
	^ sounds third level! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:58'!
offset
	^ offset! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:58'!
offset: number 
	offset _ number! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'ka 12/31/2006 00:57'!
passOver
	^ passOver! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'ka 12/31/2006 00:58'!
passOver: number 
	passOver _ number! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'ka 12/31/2006 00:58'!
passUnder
	^ passUnder! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'ka 12/31/2006 00:58'!
passUnder: number 
	passUnder _ number! !

!WsWorldStethoscope methodsFor: 'initialization' stamp: 'ka 12/31/2006 01:03'!
initialize
	fft _ FFT new: 512.
	self cutOffLevel: self defaultCutOffLevel.
	self offset: self defaultOffset.
	self passOver: self defaultPassOver.
	self passUnder: self defaultPassUnder.
	sounds _ Array
				with: WsSound new
				with: WsSound new
				with: WsSound new.
	soundInput _ SoundInputStream new samplingRate: 22050.
	sortType _ self class sortByLevelType! !

!WsWorldStethoscope methodsFor: 'constants' stamp: 'tetha 1/11/2004 22:09'!
cutOffLevelMaxValue
	^ 100000! !

!WsWorldStethoscope methodsFor: 'constants' stamp: 'tetha 1/11/2004 22:09'!
cutOffLevelMinValue
	^ 0! !

!WsWorldStethoscope methodsFor: 'constants' stamp: 'tetha 1/11/2004 22:09'!
defaultCutOffLevel
	^ 10000! !

!WsWorldStethoscope methodsFor: 'constants' stamp: 'tetha 1/11/2004 22:09'!
defaultOffset
	^ -30! !

!WsWorldStethoscope methodsFor: 'constants' stamp: 'ka 12/31/2006 01:02'!
defaultPassOver
	^ 20! !

!WsWorldStethoscope methodsFor: 'constants' stamp: 'ka 12/31/2006 01:00'!
defaultPassUnder
	^ 10000! !

!WsWorldStethoscope methodsFor: 'constants' stamp: 'tetha 1/11/2004 22:09'!
offsetMaxValue
	^ 200! !

!WsWorldStethoscope methodsFor: 'constants' stamp: 'tetha 1/11/2004 22:09'!
offsetMinValue
	^ -200! !

!WsWorldStethoscope methodsFor: 'testing' stamp: 'tetha 1/12/2004 23:30'!
isListening
	^ listening == true! !

!WsWorldStethoscope methodsFor: 'testing' stamp: 'tetha 1/11/2004 22:59'!
isSortByFrequency

	^ sortType == self class sortByFrequencyType! !

!WsWorldStethoscope methodsFor: 'testing' stamp: 'tetha 1/11/2004 22:59'!
isSortByLevel

	^ sortType == self class sortByLevelType! !

!WsWorldStethoscope methodsFor: 'sort setting' stamp: 'tetha 1/11/2004 22:56'!
sortByFrequency
	sortType _ self class sortByFrequencyType! !

!WsWorldStethoscope methodsFor: 'sort setting' stamp: 'tetha 1/11/2004 22:56'!
sortByLevel
	sortType _ self class sortByLevelType! !


!WsWorldStethoscope class methodsFor: 'instance creation' stamp: 'tetha 1/12/2004 20:36'!
default
	default isNil
		ifTrue: [default _ self basicNew initialize].
	^ default! !

!WsWorldStethoscope class methodsFor: 'instance creation' stamp: 'tetha 1/12/2004 20:36'!
new
	^ self default! !

!WsWorldStethoscope class methodsFor: 'constants' stamp: 'tetha 1/11/2004 23:15'!
sortByFrequencyType

	^ #sortByFrequencyType! !

!WsWorldStethoscope class methodsFor: 'constants' stamp: 'tetha 1/11/2004 23:15'!
sortByLevelType

	^ #sortByLevelType! !

